{ config, lib, pkgs, modulesPath, ... }:

{
  imports = [
    "${modulesPath}/profiles/base.nix"
    #"${modulesPath}/virtualisation/qemu-vm.nix"
  ];

  networking.hostName = "visionfive-nix";

  boot = {
    kernelParams = [ "boot.shell_on_fail" ];
    consoleLogLevel = lib.mkDefault 7;
    initrd.kernelModules = [
      "virtio_pci"
      "virtio_blk"
      "virtio_input"
      "9pnet"
      "9pnet_virtio"
    ];

    loader = {
      grub.enable = false;
      generic-extlinux-compatible.enable = true;
    };
  };

  nixpkgs.overlays = [ (import ./overlay.nix) ];

  # Enable ssh on boot
  services.openssh.enable = true;

  system.stateVersion = "24.05";
}
